/**
Regula de transf. din baza 8 în baza 10 este de tipul:

abcde    = a*8^4 + b*8^3 + c*8^2 + d*8 + e
     (8)

Noi citim abcde într-o variabilă. Chiar dacă cifrele
reprezintă un număr octal, variabila fiind obișnuită,
ea e în baza 10.
Deci prin împărțiri repetate la 10 obținem cifrele în
ordine inversă (e, d, c, b, a).
Pe măsură ce le obținem ne asigură că facem calculele de
mai sus: cifra curentă (e,d,c,b,a) se înmulțește rând
pe rând cu o putere din ce în ce mai mare a lui 8.
  Pentru asta putem să menținem într-o variabilă p
(inițial egal 1) puterile crescânde ale lui 8.
  O să constatăm că de fapt am dat FIX peste algoritmul
de formare de la dreapta la stânga, doar că în loc
de înmulțirea cu 10 avem înmulțire cu 8.
*/

#include <iostream>

using namespace std;

int main()
{
    int nr_dec=0,nr_oct,c,p8=1;
    cin>>nr_oct;
    do
    {
        c=nr_oct%10;
        nr_dec = nr_dec+c*p8;
        p8*=8;
        nr_oct/=10;
    }while(nr_oct);
    cout<<nr_dec;
    return 0;
}
