/**
  Ne dăm seama că, dacă orice număr par din a doua jumătate
este mai mare decât orice număr impar din a doua jumătate,
este de fapt suficient să verificăm că minimul parelor
din prima jumătate este mai mare ca maximul imparelor din a doua.
  Analog, minimul imparelor din prima jumătate trebuie să fie
mai mare ca maximul parelor din a doua.
  Astfel, din citire, determinăm min1p și min1i - minimele
parelor respectiv imparelor din prima jumătate și apoi
max2p și max2i - maximele parelor respectiv imparelor din
a doua jumătate.
   Inițializăm valorile acestora cu ceva convenabil: minimele
cu 1000001 respectiv maximele cu -1.
   Dacă la final min1p>max2i și min1i>max2p înseamnă că șirul
satisface proprietea cerută.
  Inițializările de mai sus acoperă și cazurile speciale
în care toate elementele au aceeași paritate sau în care
în vreuna dintre jumătăți lipsesc elemente de o anumită
paritate

  Alg. este eficient d.p.d.v. al timpului de executare deoarece
face puțini pași pentru că parcurge datele de intrare o singură
dată.
  Alg. este eficient d.p.d.v. al memoriei deoarece folosește
doar câteva variabile simple (nu folosește tablouri sau alte
date structurate)
*/
#include <iostream>
#include <fstream>
using namespace std;

int main()
{
    ifstream fin("bac.txt");
    int n,i,x,min1i=10000001,min1p=1000001,max2i=-1,max2p=-1;
    fin>>n;
    for(i=1;i<=n;i++)
    {
        fin>>x;
        if(x%2==0 && x<min1p)min1p=x;
        if(x%2!=0 && x<min1i)min1i=x;
    }
    for(i=1;i<=n;i++)
    {
        fin>>x;
        if(x%2==0 && x>max2p)max2p=x;
        if(x%2!=0 && x>max2i)max2i=x;
    }
    if(min1p>max2i&&min1i>max2p)cout<<"DA";
    else cout<<"NU";
    return 0;
}
