/**
  Dintr-un vector trebuie înlocuite toate secvențele de 0 cu UN singur 0.
Ex: n=11
0 2 0 0 0 0 -7 0 0 3 5
rez: n=7
0 2 0 -7 0 3 5

Dacă adoptați metoda ștergerii element cu element:
 - la găsirea a doi de 0 vecini îl ștergem pe unul dintre ei ÎNSĂ rămânem în același loc.
*/
#include <iostream>
using namespace std;

void elimina(int &n,int v[])
{
    int i,j;   ///ordin de complexitate: O(n*n)
    for(i=2;i<=n;i++)
        if(v[i-1]==0 && v[i]==0)
        {
            for(j=i;j<n;j++)
                v[j]=v[j+1];
            n--;i--;
        }
}

///iată și o rezolvare în O(n): ne facem că formăm un vector nou,
///însă punem elementele în același vector (acest lucru este posibil în cazul
///în care ștergem.
///  - în vectorul nou plasăm necondiționat a[1]
///  - parcurgem vectorul dat și adăugăm a[i] DOAR dacă el și precedentul nu sunt ambele nule.
void elimina1(int &n,int v[])
{
    int i,k=1;
    for(i=2;i<=n;i++)
        if(v[i-1]||v[i])///adică !(v[i-1]==0&&v[i]==0)
            v[++k]=v[i];
    n=k;
}


int main()
{
    int n=11,a[51]={-1727652342,0,2,0,0,0,-7,0,0,3,5};
    elimina1(n,a);
    for(int i=1;i<=n;i++)cout<<a[i]<<" ";
    cout<<"\n";
    return 0;
}
