/**
  Se consideră o matrice cu n linii și m coloane, indexată de la 0, în care
n și m sunt naturale nenule mai mici sau egale cu 10.
  Se dă un string în care avem perechi de coordonate din matrice, separate exact
printr-un singur spațiu. Coordonatele sunt ale unor elemente egale cu 1, restul
din matrice sunt egale cu 0.
  Se mai dă un alt string în care avem doar două coordonate, ale unui element
din matrice, care se garantează că este egal cu 0.

  De la ultimele coordonate date se pleacă în toate cele 8 direcții posibile:
N, NE, E, SE, S, SV, V, NV.
  Pe fiecare direcție pe care se pleacă trebuie să determinăm care este numărul
de elemente din primul grup de 1-uri întâlnite pe direcția respectivă și să afișăm
atât numărul de elemente din grup cât și direcția.
(dacă după un grup de 1 întâlnim un 0 sau dăm de marginea matricei, evident
că ne vom opri).

  Scriem o funcție care care primește ca parametri:
  - n,m - dimensiunile matricei
  - stringul cu coordonatele 1-urilor
  - stringul cu coordonatele elementului nul
  Funcția întoarce un string în care avem numărul de 1-uri găsite în grup, urmat de un
spațiu și apoi de direcție (exact ca mai sus - N, NE, E, SE, ....)

Exemplu:
Fie Matricea următoare cu 7 linii și 9 coloane
+---+---+---+---+---+---+---+---+---+
|   |   | 1 |   |   |   | 1 |   |   |
+---+---+---+---+---+---+---+---+---+
|   |   |   | 1 |   |   |   |   |   |
+---+---+---+---+---+---+---+---+---+
|   |   |   |   | 1 |   | 1 |   |   |
+---+---+---+---+---+---+---+---+---+
|   |   |   |   |   |   |   |   |   |
+---+---+---+---+---+---+---+---+---+
|   | 1 |   | 1 | 1 |   | X |   |   |
+---+---+---+---+---+---+---+---+---+
|   |   |   |   |   | 1 |   |   |   |
+---+---+---+---+---+---+---+---+---+
|   |   |   |   | 1 |   |   |   |   |
+---+---+---+---+---+---+---+---+---+
Pe exemplul acesta n=7 m=9
stringul coordonatelor 1urilor este: "02 06 13 24 26 41 43 44 55 64"
căsuța de plecare: "46"
Răspuns: 3 NV

Putem să ne facem oricâte alte funcții dorim
*/
#include <iostream>
using namespace std;

int N(int i_s,int j_s,int a[10][10],int n,int m)
{///ca să merg în NORD, scad i_s
    int nr1=0;
    while(0<=i_s&&i_s<n&&0<=j_s&&j_s<m)
    {
        if(a[i_s][j_s]==1)nr1++;///număr 1-urile
        if(a[i_s][j_s]==0&&nr1>0)break;///dacă am dat de un 0 după ce am apucat
                        ///să număr 1-uri, mă opresc (asta se cere în problemă)
        i_s--;
    }
    return nr1;
}

int NE(int i_s,int j_s,int a[10][10],int n,int m)
{///ca să merg în NORD-EST, scad i_s și cresc j_s
    int nr1=0;
    while(0<=i_s&&i_s<n&&0<=j_s&&j_s<m)
    {
        if(a[i_s][j_s]==1)nr1++;
        if(a[i_s][j_s]==0&&nr1>0)break;
        i_s--;j_s++;
    }
    return nr1;
}

int E(int i_s,int j_s,int a[10][10],int n,int m)
{///ca să merg în EST cresc j_s
    int nr1=0;
    while(0<=i_s&&i_s<n&&0<=j_s&&j_s<m)
    {
        if(a[i_s][j_s]==1)nr1++;
        if(a[i_s][j_s]==0&&nr1>0)break;
        j_s++;
    }
    return nr1;
}

int SE(int i_s,int j_s,int a[10][10],int n,int m)
{///ca să merg în SUD-EST cresc i_s, cresc j_s
    int nr1=0;
    while(0<=i_s&&i_s<n&&0<=j_s&&j_s<m)
    {
        if(a[i_s][j_s]==1)nr1++;
        if(a[i_s][j_s]==0&&nr1>0)break;
        i_s++;j_s++;
    }
    return nr1;
}

int S(int i_s,int j_s,int a[10][10],int n,int m)
{///ca să merg în SUD cresc doar i_s
    int nr1=0;
    while(0<=i_s&&i_s<n&&0<=j_s&&j_s<m)
    {
        if(a[i_s][j_s]==1)nr1++;
        if(a[i_s][j_s]==0&&nr1>0)break;
        i_s++;
    }
    return nr1;
}

int SV(int i_s,int j_s,int a[10][10],int n,int m)
{///ca să merg în SUD-VEST cresc i_s și scad j_s
    int nr1=0;
    while(0<=i_s&&i_s<n&&0<=j_s&&j_s<m)
    {
        if(a[i_s][j_s]==1)nr1++;
        if(a[i_s][j_s]==0&&nr1>0)break;
        i_s++;j_s--;
    }
    return nr1;
}

int V(int i_s,int j_s,int a[10][10],int n,int m)
{///ca să merg în VEST scad j_s
    int nr1=0;
    while(0<=i_s&&i_s<n&&0<=j_s&&j_s<m)
    {
        if(a[i_s][j_s]==1)nr1++;
        if(a[i_s][j_s]==0&&nr1>0)break;
        j_s--;
    }
    return nr1;
}

int NV(int i_s,int j_s,int a[10][10],int n,int m)
{///ca să merg în NORD-VEST scad atât i_s cât și j_s
    int nr1=0;
    while(0<=i_s&&i_s<n&&0<=j_s&&j_s<m)
    {
        if(a[i_s][j_s]==1)nr1++;
        if(a[i_s][j_s]==0&&nr1>0)break;
        i_s--;j_s--;
    }
    return nr1;
}

string rezolva(int n,int m,string s1,string st)
{
    int a[10][10]={0};///sintaxa asta declară matricea și inițializează toate elementele cu 0
    ///punem 1urile în matrice: trebuie să luăm stringul s1 - mai precis numerele din el
    ///și la coordonatele respective să punem 1
    int rezc,mx=0,i,j,k=0;///ne luăm indicele k ca să parcurgem stringul s1 caracter cu caracter
    string dirmax;
    while(k<s1.size())
    {
        i=s1[k]-'0';///obs: s1[k] este cifră caracter - deci dacă nu am scădea 0
        j=s1[k+1]-'0';  ///am rămâne cu codul ASCII
        a[i][j]=1;
        k=k+3;
    }
    int i_s,j_s;///indicii de la care pornim numărarea
    i_s=st[0]-'0';
    j_s=st[1]-'0';
    rezc=N(i_s,j_s,a,n,m);
    if(rezc>mx){mx=rezc;dirmax="N";}
    rezc=NE(i_s,j_s,a,n,m);
    if(rezc>mx){mx=rezc;dirmax="NE";}
    rezc=E(i_s,j_s,a,n,m);
    if(rezc>mx){mx=rezc;dirmax="E";}
    rezc=SE(i_s,j_s,a,n,m);
    if(rezc>mx){mx=rezc;dirmax="SE";}
    rezc=S(i_s,j_s,a,n,m);
    if(rezc>mx){mx=rezc;dirmax="S";}
    rezc=SV(i_s,j_s,a,n,m);
    if(rezc>mx){mx=rezc;dirmax="SV";}
    rezc=V(i_s,j_s,a,n,m);
    if(rezc>mx){mx=rezc;dirmax="V";}
    rezc=NV(i_s,j_s,a,n,m);
    if(rezc>mx){mx=rezc;dirmax="NV";}
    return to_string(mx)+" "+dirmax;
}

int main()
{
    cout << rezolva(7,9,"02 06 13 24 26 41 43 44 55 64","46");
    return 0;
}
