/**
  Se consideră o matrice cu n linii și m coloane, indexată de la 0, în care
n și m sunt naturale nenule mai mici sau egale cu 10.
  Se dă un string în care avem perechi de coordonate din matrice, separate exact
printr-un singur spațiu. Coordonatele sunt ale unor elemente egale cu 1, restul
din matrice sunt egale cu 0.
  Se mai dă un alt string în care avem doar două coordonate, ale unui element
din matrice, care se garantează că este egal cu 0.

  De la ultimele coordonate date se pleacă în toate cele 8 direcții posibile:
N, NE, E, SE, S, SV, V, NV.
  Pe fiecare direcție pe care se pleacă trebuie să determinăm care este numărul
de elemente din primul grup de 1-uri întâlnite pe direcția respectivă și să afișăm
atât numărul de elemente din grup cât și direcția.
(dacă după un grup de 1 întâlnim un 0 sau dăm de marginea matricei, evident
că ne vom opri).

  Scriem o funcție care care primește ca parametri:
  - n,m - dimensiunile matricei
  - stringul cu coordonatele 1-urilor
  - stringul cu coordonatele elementului nul
  Funcția întoarce un string în care avem numărul de 1-uri găsite în grup, urmat de un
spațiu și apoi de direcție (exact ca mai sus - N, NE, E, SE, ....)

Exemplu:
Fie Matricea următoare cu 7 linii și 9 coloane
+---+---+---+---+---+---+---+---+---+
|   |   | 1 |   |   |   | 1 |   |   |
+---+---+---+---+---+---+---+---+---+
|   |   |   | 1 |   |   |   |   |   |
+---+---+---+---+---+---+---+---+---+
|   |   |   |   | 1 |   | 1 |   |   |
+---+---+---+---+---+---+---+---+---+
|   |   |   |   |   |   |   |   |   |
+---+---+---+---+---+---+---+---+---+
|   | 1 |   | 1 | 1 |   | X |   |   |
+---+---+---+---+---+---+---+---+---+
|   |   |   |   |   | 1 |   |   |   |
+---+---+---+---+---+---+---+---+---+
|   |   |   |   | 1 |   |   |   |   |
+---+---+---+---+---+---+---+---+---+
Pe exemplul acesta n=7 m=9
stringul coordonatelor 1urilor este: "02 06 13 24 26 41 43 44 55 64"
căsuța de plecare: "46"
Răspuns: 3 NV

Putem să ne facem oricâte alte funcții dorim
*/
#include <iostream>
using namespace std;

string rezolva(int n,int m,string s1,string st)
{
    int a[10][10]={0};///sintaxa asta declară matricea și inițializează toate elementele cu 0
    ///punem 1urile în matrice: trebuie să luăm stringul s1 - mai precis numerele din el
    ///și la coordonatele respective să punem 1
    int rezc,mx=0,i,j,k=0;///ne luăm indicele k ca să parcurgem stringul s1 caracter cu caracter
    string dirmax;
    while(k<s1.size())
    {
        i=s1[k]-'0';///obs: s1[k] este cifră caracter - deci dacă nu am scădea 0
        j=s1[k+1]-'0';  ///am rămâne cu codul ASCII
        a[i][j]=1;
        k=k+3;
    }
    int i_s,j_s;///indicii de la care pornim numărarea
    i_s=st[0]-'0';
    j_s=st[1]-'0';
    string dir[8]={"N","NE","E","SE","S","SV","V","NV"};
    int di[8]={-1,-1,0,1,1,1,0,-1};
    int dj[8]={0,1,1,1,0,-1,-1,-1};
    int i1,j1,nr1;
    for(k=0;k<8;k++)
    {///ceea ce-am programat în funcție programez cu dir[k], di[k] și dj[k]
        i1=i_s;j1=j_s;///de data asta nu mai pot lucra cu i_s și j_s pentru că s-ar modifica
        ///și le-aș pierde pe cele inițiale. Așa că la fiecare testare de direcție
        ///nouă, gen la fiecare creștere de k, pornesc cu alte variabile, i1 și j1
        nr1=0;
        while(0<=i1&&i1<n&&0<=j1&&j1<m)
        {
            if(a[i1][j1]==1)nr1++;
            if(a[i1][j1]==0&&nr1>0)break;
            i1+=di[k];j1+=dj[k];///iar fiecare i1 și j1 crește personalizat cu di[k]
            ///respectiv dj[k] - și anume cei 2 vectori pe care mi i-am pregătit în acest scop
        }
        if(nr1>mx){mx=nr1;dirmax=dir[k];}///iar dacă am maxim rețin stringul direcției respective
    }
    return to_string(mx)+" "+dirmax;
}

int main()
{
    cout << rezolva(7,9,"02 06 13 24 26 41 43 44 55 64","46");
    return 0;
}
